/**
 * 表单整体较验
 */
(function(jq) {
	
	//加载样式 
	//var path, scripts = document.getElementsByTagName("SCRIPT");
	//for (var i = 0; i < scripts.length; i++) {
	//	path = scripts[i].src.substring(0, scripts[i].src.indexOf("/common/validation/validation.js"));
	//	if (path) break;
	//}
	
	String.prototype.lenbyte = function() {
	  return this.replace(/[^\x00-\xff]/g,"**").length;
	};
	
	var _result = true; // 较验结果 验证返回值 默认true
	//错误信息
	var _ERROR = {
		ERROR_FORMAT: '格式错误！',
		NOT_NULL: '必填项！',
		OUT_OF_MAXLEN: '不能超过#{max}汉字或#{maxlen}字符！',
		OUT_OF_MINLEN: '最少#{minlen}个字符！',
		INVALID_NUMBER: '无效数字！',
		INVALID_INT: '只能填整数！',
		OUT_OF_NUMBER_BIT: '最多#{maxlen}位有效数字！',
		OUT_OF_DECIMALS_BIT: '最多#{maxlen}位小数！',
		OUT_OF_INT_BIT: '最多#{maxlen}位整数!',
		DATE_ERROR: '正确格式：yyyy-MM-dd！',
		TIME_ERROR: '正确格式：hh:mm:ss！',
		DATETIME_ERROR: '正确格式：yyyy-MM-dd hh:mm:ss！',
		MOBILE_ERROR: '无效的手机号码！',
		TELEPHONE_ERROR: '无效的电话号码！',
		FAX_ERROR: '无效的传真号码！',
		POSTALCODE_ERROR: '无效的邮政编码！',
		EMAIL_ERROR: '无效的电子邮箱！',
		IDCARD_ERROR: '无效的身份证号！',
		ORGAN_ERROR: '正确格式：12345678-X！'
	};
	/**
	 * text录入框验证
	 * 提供验证type类型
	 * 不包含'必填'的验证
	 * 非数字 不包含'长度'的验证
	 */
	var _text = {
		//普通字符
		'char': function(vs) {
			
		},
		//日期
		date: function(vs) {
			var val = vs.value;
			var reg = /^[1-9][0-9]{3}-([0-9]|(0[0-9])|(1[0-2]))-([0-9]|([0-2][0-9])|([3][0-1]))$/g;
			if(!reg.test(val))
				throw _ERROR.DATE_ERROR;
		},
		//时间
		time: function(vs) {
			var val = vs.value;
			var reg = /^([0-9]|([0-1][0-9])|2[0-3]):([0-9]|([0-5][0-9])):([0-9]|([0-5][0-9]))$/g;
			if(!reg.test(val))
				throw _ERROR.TIME_ERROR;
		},
		//日期 时间
		datetime: function(vs) {
			var val = vs.value;
			var reg = /^[1-9][0-9]{3}-([0-9]|(0[0-9])|(1[0-2]))-([0-9]|([0-2][0-9])|([3][0-1]))[ ]([0-9]|([0-1][0-9])|2[0-3]):([0-9]|([0-5][0-9])):([0-9]|([0-5][0-9]))$/g;
			if(!reg.test(val))
				throw _ERROR.DATETIME_ERROR;
		},
		//手机
		mobile: function(vs) {
			var val = vs.value;
			var reg=/^[1]\d{10}$/g;
			if(!reg.test(val))
				throw _ERROR.MOBILE_ERROR;
		},
		//座机
		telephone: function(vs) {
			var val = vs.value;
			var reg=/^(\d{3,4}-)?\d{7,8}(-\d{1,8})?$/g;
			if(!reg.test(val))
				throw _ERROR.TELEPHONE_ERROR;
		},
		//手机 or 座机
		phone: function(vs) {
			var val = vs.value;
			var reg=/(^(\+86)?[ ]?\d{11}$)|(^(\d{3,4}-)?\d{7,8}(-\d{1,8})?$)/g;
			if(!reg.test(val))
				throw _ERROR.TELEPHONE_ERROR;
		},
		//传真
		fax: function(vs) {
			var val = vs.value;
			var reg=/^(\d{3,4}-)?\d{7,8}(-\d{1,8})?$/g;
			if(!reg.test(val))
				throw _ERROR.FAX_ERROR;
		},
		//邮编
		postalcode: function(vs) {
			var val = vs.value;
			var reg=/^\d{6}$/g;
			if(!reg.test(val))
				throw _ERROR.POSTALCODE_ERROR;
		},
		//电子邮箱
		email: function(vs) {
			var val = vs.value;
			var reg=/^[\.a-z0-9_-]+@([a-z0-9_-]+\.)+[a-z0-9_-]+$/gi;
			if(!reg.test(val))
				throw _ERROR.EMAIL_ERROR;
		},
		//浮点数字
		number: function(vs) {
			var val = vs.value;
			var reg = /^[0-9]+(\.[0-9]+)?$/g;
			if(!reg.test(val)){
				throw _ERROR.INVALID_NUMBER;
			}
			
			if(!vs.length) {
				return;
				}
			var maxlen = 0, xl = -1;
			if(vs.length.toString().indexOf(',') < 0) {
				maxlen = vs.length;
			} else {
				var tem = vs.length.split(',');
				maxlen = tem[0];
				xl = tem[1];
			}
			var INT = parseInt(maxlen) - parseInt(xl);
			var _throw = '';
			if(val.toString().replace('.','').length > maxlen){
				_throw += _ERROR.OUT_OF_NUMBER_BIT.replace('#{maxlen}',maxlen);
			}
			
			
			if(xl != -1) {
				var tem = val.toString().split('.');
				if(tem[0] && tem[0].toString().length > INT){
					_throw += _ERROR.OUT_OF_INT_BIT.replace('#{maxlen}',INT);
				}
				if(tem[1] && tem[1].toString().length>xl) {
					_throw += _ERROR.OUT_OF_DECIMALS_BIT.replace('#{maxlen}',xl);
				}
			}
			if(_throw != '')
				throw _throw;
		},
		//整形
		'int': function(vs) {
			var val = vs.value;
			var reg = /^[0-9]*$/g;
			if(!reg.test(val))
				throw _ERROR.INVALID_INT;
			if(!vs.length) 
				return;
			var len = vs.length.toString().split(",");
			if(val.toString().length > len[0]) 
				throw _ERROR.OUT_OF_NUMBER_BIT.replace('#{maxlen}', len[0]);
		},
		//身份证暂只验证位数(验证15位 18位)
		idcard: function(vs) {
			var re = false; 
			if('IdCardValidate' in window) {
				re = IdCardValidate(vs.value);
			} else {
				var reg=/^(([0-9]{15})|([0-9]{17}[0-9x]))$/gi;
				re = reg.test(vs.value);
			}
			if(!re)
				throw _ERROR.IDCARD_ERROR;
		},
		//组织机构
		organ: function(vs) {
			var val = vs.value;
			var reg=/^[0-9a-z]{8}-[0-9a-z]$/gi;
			if(!reg.test(val))
				throw _ERROR.ORGAN_ERROR;
		}
	};
	/**
	 * 通用方法
	 * 验证非数字长度
	 * @param {Object} vs
	 */
	var _length = function(vs) {
		
		var len = vs.length  //字符最大长度
		var val = vs.value;  //输入的字符
		var maxlen=0, minlen=0;
		if(len.toString().indexOf(',') < 0) {
			maxlen = len;
		} else {
			var tem = len.split(',');
			maxlen = tem[0];
			minlen = tem[1];
		}
		//var blen = val.lenbyte(); //输入字符的长度
		var blen=0 
    	for (var i=0;i<val.length;i++) 
    	{ 
        	if ((val.charCodeAt(i) < 0) || (val.charCodeAt(i) > 255)) 
            	blen=blen+2 
        	else 
            	blen=blen+1    
    	}
		if(blen>maxlen) {
			throw _ERROR.OUT_OF_MAXLEN.replace('#{maxlen}',maxlen).replace('#{max}',Math.floor(maxlen/2));
		} else if(blen<minlen) {
			throw _ERROR.OUT_OF_MINLEN.replace('#{minlen}',minlen);
		}
	};
	/**
	 * 根据pattern属性的正则字符串验证录入项
	 * @param {Object} vs 
	 */
	var _pattern = function(vs) {
		var val = vs.value;
		var reg = vs.pattern;
		var g = '';
		var a = reg.toString().indexOf('/');
		if(a==0) reg = reg.toString().substr(1);
		var b = reg.toString().lastIndexOf('/');
		var c = reg.toString().length;
		if(c-b == 2) { 
			g = reg.substr(c-1);
		} 
		if(c-b == 1 || c-b == 2) {
			reg = reg.toString().substring(0,b);
		}
		
		reg = new RegExp(reg,g);
		if(!reg.test(val))
			throw _ERROR.ERROR_FORMAT;
	};
	/**
	 * 格式化较验字符串
	 * 字符串 转 Object {}
	 * @param {Object} v 较验字符串
	 */
	var _formatValids = function(v) {
		var _v = {};
		if(v!=null&&v!=""){
		
			var vs = v.split(";");
		for(var i=0; i<vs.length; i++) {
			var p = vs[i].split("=");
			if(p.length==2)
				_v[p[0]] = p[1];
		}
		}
		
		return _v;
	};
	/**
	 * 验证单个录入项
	 * @param {Object} vs 封装的较验对象
	 */
	var _check = function(vs) {
		try{
			//验证是否必填
			if(vs.required != 'true' && vs.value == '') return true;
			if(vs.required == 'true' && jq.trim(vs.value) == '') {
			//	throw _ERROR.NOT_NULL;
				$.toast(vs['key']+_ERROR.NOT_NULL);
				return false;
			}
			//验证非数字的长度
			if(vs.type!='number' && vs.type!='int' && vs.length)
				_length(vs);
			
			//区分正则验证还是普通验证
			if(!!vs.pattern) {
				_pattern(vs);
			} else {
				if( vs.type && _text[vs.type]) {
					//vs._type=text、textarea、select-one
					_text[vs.type](vs);
				}
			}
			return true;
		} catch(e) {
			if(typeof e != 'string') 
				throw e;
			
			if(!!vs.mess)
				e = vs.mess;
			$.toast(vs['key']+e);
			return false;
		}
	};
	/**
	 * 验证单个录入项
	 */
	jq.fn.checkOne = function() {
		var v = jq(this).attr("check");
		var vs = _formatValids(v); //格式化验证字符串
		vs['_type'] = jq(this).attr("type")?jq(this).attr("type"):this.type; //录入对象类型 text/textarea/select
		vs['pattern'] = jq(this).attr("pattern");
		vs['mess'] = jq(this).attr("mess");
		vs['value'] = jq(this).val()?jq(this).val():'';
		vs['th'] = jq(this);
		return _check.call(this,vs);
	}
	
	/**
	 * 提供表单验证方法
	 */
	jq.fn.checkForm = function() {
		_result = true;
		
		var vl = jq(this).find("input[check]:visible:enabled,textarea[check]:visible:enabled,select[check]:visible:enabled");
		vl.each(function(i) {
			var flag = jq(this).checkOne();
			if(!flag){
				_result = flag;
			}
			return flag;
		});
		
		return _result;
	};
	/**
	 * 单个录入框，初始化校验事件
	 * @memberOf {TypeName} 
	 */
	jq.fn.initValidInfo = function() {
		jq(this).blur(function() {
			jq(this).checkOne();
		});
	}
	window.checkOne = function(id) {
		return jq("#"+id).checkOne();
	}
})(jQuery);