/**
 * 调转到在线培训
 */
function sendBroadcast(event, data) {
    cordova.exec(null, null, "ARouterPlugin", "SendBroadcast", [event, data])
}

/**
 * 调转到在线培训
 */
function gotoTrainingOnline() {
    cordova.exec(null, null, "ARouterPlugin", "TrainingOnline", [])
}

/**
 * 跳转到星期三查餐厅
 */
function gotoWednesdayInspect() {
    cordova.exec(null, null, "ARouterPlugin", "WednesdayInspect", [])
}

/**
 * 跳转到操作手册
 */
function gotoHelpCenter() {
    cordova.exec(null, null, "ARouterPlugin", "HelpCenter", [])
}

/**
 * 跳转到意见和建议
 */
function gotoFeedback() {
    cordova.exec(null, null, "ARouterPlugin", "Feedback", [])
}

/**
 * 调转到线索推送H5
 */
function gotoCuePush() {
    cordova.exec(null, null, "ARouterPlugin", "CuePush", [])
}

/**
 * 调转到消息通知
 */
function gotoNotice() {
    var noticeCount = getUserLocalStorage("noticeCount")
    cordova.exec(null, null, "ARouterPlugin", "ActionNotice", [noticeCount])
}

/**
 * 获取消息通知数量
 */
function getNoticeCount() {
    cordova.exec(function (data) {
        console.log(data)
        var noticeCount = JSON.parse(data);
        setUserLocalStorage("noticeCount", data)
        // index_new.js 方法
        setNoticeBubble(noticeCount.totalBubble);
    }, null, "ARouterPlugin", "NoticeCount", [])
}

/**
 * 获取健康证预警气泡数量
 */
function getHealthWarningCount(callBack) {
    cordova.exec(function (data) {
        callBack(data)
    }, null, "ARouterPlugin", "HealthWarningCount", [])
}

/**
 * 获取食安证预警气泡数量
 */
function getSafetyWarningCount(callBack) {
    cordova.exec(function (data) {
        callBack(data)
    }, null, "ARouterPlugin", "SafetyWarningCount", [])
}

/**
 * 跳转到扫码界面
 */
function gotoQRCodeScan() {
    cordova.exec(function (data) {
        setScanResult(data);
    }, null, "ARouterPlugin", "ActionCapture", [])
}

/**
 * 调转到食品安全巡查页面
 */
function gotoTaskSecurityCheck(modularType, callback) {
    // 列表项数据
    var data = JSON.parse(window.localStorage.getItem("dataList"));
    var enterprise = null;
    var mobilePath = "";
    var tasktypecode = null;
    var tasktypename = null;

    if (undefined == data.taskid || null == data.taskid){
        enterprise = {
            entregNo: data.entregno,
            dietProviderName: data.entName,
            dietProviderAddr: data.address,
            dietProviderId: data.entId,
            director: data.lerep
        };
        mobilePath = "/task/InspectEnterpriseListActivity";
    } else {
        enterprise = {
            entregNo: data.entregno,
            dietProviderName: data.entname,
            dietProviderAddr: data.addr,
            dietProviderId: data.entid,
            director: data.lerepname,
            taskId: data.taskid,
        };
        tasktypecode = data.tasktypecode;
        tasktypename = data.tasktypename;
        mobilePath = "/task/TaskListActivity";
    }

    var taskid = undefined == data.taskid ? null : data.taskid;
    var strEnterprise = JSON.stringify(enterprise);
    console.log("strEnterprise: " + strEnterprise);
    cordova.exec(function (result) {
        if (undefined != callback) {
            // 任务执行完成回调
            callback(result);
        }
    }, function (error) {
        console.log("Location Plugin Error");
    }, "ARouterPlugin", "TaskInspectStatus", [modularType == 'yb' ? "View" : "Edit", strEnterprise, taskid, tasktypecode, tasktypename, mobilePath]);
}

/**
 * 调转到食品安全巡查页面
 */
function gotoTaskSecurityTemplate(callback) {
    // 列表项数据
    var data = JSON.parse(window.localStorage.getItem("dataList"));
    var mobilePath = "/task/InspectEnterpriseListActivity";
    var enterprise = {
        dietProviderName: data.entName,
        dietProviderAddr: data.address,
        dietProviderId: data.entId,
        director: data.lerep
    };

    var taskid = undefined == data.taskid ? null : data.taskid;
    var strEnterprise = JSON.stringify(enterprise);
    console.log("strEnterprise: " + strEnterprise);
    cordova.exec(function (result) {
        if (undefined != callback) {
            // 任务执行完成回调
            callback(result);
        }
    }, function (error) {
        console.log("Location Plugin Error");
    }, "ARouterPlugin", "TaskInspectTemplate", ["Edit", strEnterprise, taskid, mobilePath,
        enterprise.dietProviderId, enterprise.dietProviderName]);
}

/**
 * 调转到食品安全巡查页面
 */
function gotoTaskDetail() {
    // 列表项数据
    var data = JSON.parse(window.localStorage.getItem("dataList"));
    var taskInfo = {
        entregNo: data.entregno,
        director: data.lerepname,
        linkPhone: data.linkPhone,
        dietProviderAddr:data.addr,

    }
    var strTaskInfo = JSON.stringify(taskInfo);
    cordova.exec(function (result) {
    }, function (error) {
        console.log("Location Plugin Error");
    }, "ARouterPlugin", "TaskDetail", [data.taskid, data.entname, strTaskInfo]);
}

/**
 * 调转到整改单详情
 */
function gotoRectificationDetail(modularType) {
    // 列表项数据
    var data = JSON.parse(window.localStorage.getItem("dataList"));
    cordova.exec(function (result) {
    }, function (error) {
        console.log("Location Plugin Error");
    }, "ARouterPlugin", "RectificationDetail", [modularType == 'yb' ? "View" : "Edit", data.taskid, "", ""]);
}

/**
 * 跳转食材追溯页面
 */
function toFoodTrace() {
    cordova.exec(null, null, "ARouterPlugin", "FoodTraceActivity", []);
}

/**
 * 跳转企业自查页面
 */
function toSelfInspect() {
    cordova.exec(null, null, "ARouterPlugin", "SelfInspect", []);
}

/**
 * 跳转抽检不合格页面
 */
function toDetectionWarning() {
    cordova.exec(null, null, "ARouterPlugin", "DetectionWarning", []);
}

/**
 * 跳转食安管理员页面
 */
function toSafetyCerWarning() {
    cordova.exec(null, null, "ARouterPlugin", "SafetyCerWarning", []);
}

/**
 * 跳转健康证页面
 */
function toHealthCertificateWarning() {
    cordova.exec(null, null, "ARouterPlugin", "HealthCertificateWarning", []);
}

/**
 * 跳转"深圳智慧监管"App餐企详情页面
 * Id: 餐企Id
 * licenseKey: 许可证号
 */
function toEnterpriseDetail(Id, licenseKey) {
    cordova.exec(null, null, "ARouterPlugin", "EnterpriseDetail", [Id, licenseKey]);
}

/**
 * 跳转任务统计页面
 */
function gotoTaskCount(startTime, endTime) {
    cordova.exec(null, null, "ARouterPlugin", "TaskCount", [startTime, endTime]);
}

/**
 * 跳转巡查统计页面
 */
function gotoInspectCount(startTime, endTime) {
    console.log("startTime="+startTime+",endTime="+endTime);
    cordova.exec(null, null, "ARouterPlugin", "InspectCount", [startTime, endTime]);
}

/**
 * 跳转巡查统计页面
 */
function gotoRefreshUserInfo(user, depType) {
    if (null == user){
        cordova.exec(null, null, "ARouterPlugin", "RefreshUserInfo", [""]);
        return;
    }

    var userInfo = {
        dep_code: user.dep_code,
        type: getUserType(),
        userType: "1",
        token: "f11bbd4d0df54de0a0c0354383894e65",
        userId: user.sys_right_user_id,
        user_Name: user.user_name,
        wgcode: user.gridGroupsID,
        depCode: getUniqueCode(),
        depType: depType,
        telephone: user.mob_tel,
        positionList: [{
            code: "PS0004",
        }]
    }
    cordova.exec(null, null, "ARouterPlugin", "RefreshUserInfo", [JSON.stringify(userInfo)]);
}

/**
 * 获取任务统计数据
 */
function getTaskCount(startTime, endTime, uniqueCode, type) {
    var countJson = {
        total: 0,
        completedQty: 0,
        uncompletedQty: 0,
    };
    var countParams = {
        uniqueCode: uniqueCode,
        startTime: startTime,
        endTime: endTime,
        type: type,
    };
    cordova.exec(function (countJson) {
//        console.log(JSON.stringify(data))
        // index_new.js 方法
        setTaskCount(countJson.total, countJson.completedQty, countJson.uncompletedQty);
    }, null, "ARouterPlugin", "TaskCountNum", [JSON.stringify(countParams)]);
}

/**
 * 获取巡查统计数据
 */
function getInspectCount(startTime, endTime, uniqueCode, type) {
    var countJson = {
        unInspectQty: 0,
        inspectQty: 0,
        unLicensedQty: 0,
    };
    var countParams = {
        uniqueCode: uniqueCode,
        startTime: startTime,
        endTime: endTime,
        type: type,
    };
    cordova.exec(function (countJson) {
        setInspectCount(countJson.unInspectQty, countJson.inspectQty, countJson.unLicensedQty);
    }, null, "ARouterPlugin", "InspectCountNum", [JSON.stringify(countParams)]);
}

/**
 * 打开签名
 */
function gotoTaskSignture(domain) {
    cordova.exec(function (imageBase64) {
        uploadSigntureImage(imageBase64, domain)
    }, null, "ARouterPlugin", "TaskSignture", []);
}

/**
 * 获取任务执行状态，executeState
 */
function getTaskExecutestate(taskId, callback) {
    cordova.exec(function (data) {
        callback(data);
    }, null, "ARouterPlugin", "GetTaskExecutestate", [taskId]);
}

/**
 * 打开新的二级页面
 */
function gotoNewWebPage(launchUrl, params) {
    var urlconfig = window.localStorage.getItem('urlconfig');
    var username = window.localStorage.getItem('username');
    var yhm = window.localStorage.getItem('yhm');//姓名
    var deptname = window.localStorage.getItem('deptname');//部门名称
    var data = {
        urlconfig:urlconfig,
        username:username,
        yhm:yhm,
        deptname:deptname,
        launchUrl:launchUrl,
    };

    for (var key in params) {
        data[key] = params[key];
    }

    cordova.exec(null, null, "ARouterPlugin", "NewWebPage", [JSON.stringify(data)]);
}
/**
 * 调转整改跟进页面
 */
function toRectification() {
    cordova.exec(null, null, "ARouterPlugin", "Rectification", [])
}