/**
 * 获取 DIV params
 */
function getFormData(eleId) {
    var data = {};
    $("input,select,textarea", $("#" + eleId)).each(function (i) {
        var name = $(this).attr("name");

        //获取元素类型
        var typeInput = $(this).attr("type");
        if ($.type(typeInput) === 'undefined') {
            typeInput = $(this).is("select") ? "select" : $(this).is("textarea") ? "textarea" : "";
        }

        var val = null;
        //获取数据
        if (typeInput == "radio" || typeInput == "checkbox") {
            val = $("[name='" + name + "']:checked").val();
        } else if (typeInput == "text" || typeInput == "hidden" || typeInput == "date") {
            val = $(this).val();
        } else if (typeInput == "select") {
            val = $(this).val();
        } else if (typeInput == "textarea") {
            val = $(this).val();
        }

        if (undefined != data[name] && null != data[name]) {
            if (typeInput == "radio" || typeInput == "checkbox") {
                data[name] = val;
            } else {
                data[name] = data[name] + "," + val;
            }
        } else {
            data[name] = val;
        }

    });
    return data;
}

function getUserType() {
    // 0-市局；1-分局；2-所；3-网格
    return getUserLocalStorage('userType');
}

function getUniqueCode() {
    var userType = getUserType();
    if ('0' == userType) {
        return '0000';
    } else if ('1' == userType) {
        return getParentDepCode();
    } else if ('2' == userType) {
        return getDepCode();
    } else if ('3' == userType) {
        return getGridCode();
    } else {
        return ''
    }
}

/**
 * 1. userType = 0, 市局，  使用 0000;
 * 2. userTYpe = 1, 分局，  使用 parent_dep_code;
 * 3. userTYpe = 2, 监管所，使用 dep_code;
 * 4. userTYpe = 3, 网格，  使用 gridID;
 * @returns {*}
 */
function getDepCode() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        return userInfo.dep_code;
    }catch (e) {
        return '';
    }

}

function getParentDepCode() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        // console.log(JSON.stringify(userInfo));
        return userInfo.departmentInfo.parent_dep_code;
    }catch (e) {
        return '';
    }
}

function getDepartmentInFo() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        // console.log(JSON.stringify(userInfo));
        return userInfo.departmentInfo;
    }catch (e) {
        return '';
    }
}

function getGridCode() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        return userInfo.gridID;
    }catch (e) {
        return '';
    }
}

function getUserName() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        return userInfo.user_name;
    }catch (e) {
        return '';
    }
}

function getSysUserName() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        return userInfo.sys_user_name;
    }catch (e) {
        return '';
    }
}

function getSysUserId() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        return userInfo.sys_right_user_id;
    }catch (e) {
        return '';
    }
}

function getUserName() {
    try {
        var userInfo = JSON.parse(getUserLocalStorage('userInfo'));
        return userInfo.user_name;
    }catch (e) {
        return '';
    }
}

function setUserLocalStorage(key,value) {
    if(window.localStorage.getItem('username')){
        var userName = window.localStorage.getItem('username');
        window.localStorage.setItem(userName + '_' + key,value);
    }
}

function getUserLocalStorage(key) {
    if(window.localStorage.getItem('username')){
        var userName = window.localStorage.getItem('username');
        return window.localStorage.getItem(userName + '_' + key);
    }
}

function onBack() {
    var launchUrl = window.localStorage.getItem("launchUrl");
    console.log("launchUrl == " + launchUrl)
    console.log("window.location.href == " + window.location.href)
    if (window.location.href.indexOf(launchUrl) > -1){
        navigator.app.exitApp();
    }else {
        window.history.back(-1);
    }
}

/**
 * 判断是否选中
 * @returns {*}
 */
function getSelection(feeditemid) {
    var Selection = $('input[name=\'' + feeditemid + '\']:checked').val();
    return Selection == undefined ? null : Selection;
}
/**
 * 生成32位UUID
 * */
function uuid() {
    var s = [];
    var hexDigits = "0123456789abcdef";
    for (var i = 0; i < 36; i++) {
        s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
    }
    s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
    s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
    s[8] = s[13] = s[18] = s[23] = "";

    var uuid = s.join("");
    return uuid;
}
