var jq = jQuery.noConflict();

(function () {
    document.addEventListener("deviceready", onDeviceReady, false);
})();

function onDeviceReady() {
    $.showPreloader();
    getLocation();
}

function getLocation() {
    cordova.exec(function (result) {
        var lat = result.lat;
        var lon = result.lon;

        loadData(lat,lon);
        initMap(lat,lon);
    },function (error) {
        console.log("Location Plugin Error");
    },"LocationPlugin","getLocation",[]);

    //cordova的定位插件不好用，尤其是android 6.0
    // navigator.geolocation.getCurrentPosition(function (position) {
    //     var lat = position.coords.latitude;
    //     var lon = position.coords.longitude;
    //
    //     loadData(lat,lon);
    //     initMap(lat,lon);
    // },function (error) {
    //     console.log('code: '    + error.code    + '\n' +
    //         'message: ' + error.message + '\n');
    // })
}

function initMap(lat,lon) {
    var map = new BMap.Map("container");                     // 创建Map实例
    var point = new BMap.Point(lon,lat);        // 创建点坐标
    map.centerAndZoom(point, 15);                            // 初始化地图,设置中心点坐标和地图级别。
    var marker = new BMap.Marker(point);                        // 创建标注
    map.addOverlay(marker);                                    //将标注添加到地图中
}

function loadData(lat,lon) {
    jq.ajax({
        url: window.localStorage.getItem("ipconfig")+"/web/appinterface/company/querySurroundingList.xhtml",
        type: 'post',
        data: {
            latitude:lat,
            longitude:lon
        },
        async: true,
        dataType: "json",


        success: function (data, textStatus) {
            $.hidePreloader();
            var resultList = data.data.resultList;
            for(var i=0;i<resultList.length;i++){
            if(resultList[i].distance!="999999999999"){
             jq("#qy_ul").append("<li onclick=\"gotoBusinessDetail('"+resultList[i].id+"','"+resultList[i].xkzid+"')\"><span class=\"num\">"+(i+1)+"</span>"+resultList[i].name+"<span class=\"distance\">"+resultList[i].distance+"m</span></li>");
            }else{
            jq("#qy_ul").append("<li onclick=\"gotoBusinessDetail('"+resultList[i].id+"','"+resultList[i].xkzid+"')\"><span class=\"num\">"+(i+1)+"</span>"+resultList[i].name+"<span class=\"distance\"></span></li>");
            }


            }
        },
        error: function (data, textStatus) {
            $.hidePreloader();
            $.alert("提示：服务链接异常。");
        }
    });
}

function gotoBusinessDetail(qyid,xkzid) {
    window.localStorage.setItem('qyid',qyid);
    window.localStorage.setItem('xkzid',xkzid);
    window.location.href="../qyml/business_detail.html";
}