var jq = jQuery.noConflict();
var ipconfig = window.localStorage.getItem('urlconfig');
var map;
var firstDrawMyLoc = true;//
var selfLon = "";
var selfLat = "";
var EARTH_RADIUS = 6378137.0;    //单位M
var PI = Math.PI;
(function () {
    document.addEventListener("deviceready", onDeviceReady, false);
})();

function onDeviceReady() {
    //初始化地图
    mp = new BMap.Map("container");

    getLocation();
    // setInterval(getLocation,1000*60);
}

function getLocation() {
    cordova.exec(function (result) {
        var lat = result.lat;
        var lon = result.lon;
          selfLat = parseFloat(result.lat);
          selfLon = parseFloat(result.lon);
        //清除地图上所有覆盖物
        mp.clearOverlays();
        //定位成功后，描点当前位置
        // drawMyLoc(lat,lon);
        //加载列表数据
        // var dataList = JSON.parse(window.localStorage.getItem('arrayObj'));

        initData();
      
    },function (error) {
        console.log("Location Plugin Error");
    },"LocationPlugin","getLocation",[]);
}

//描点用户当前位置
function drawMyLoc(lat,lon) {
    var point = new BMap.Point(lon,lat);        // 创建点坐标
    var marker = new BMap.Marker(point);                        // 创建标注
    mp.addOverlay(marker);                                    //将标注添加到地图中
    //如果是进页面第一次描点当前位置，设置中心坐标和放大级别
    if(firstDrawMyLoc){
        mp.centerAndZoom(point, 15);
        firstDrawMyLoc = false;
    }
}

//加载列表数据
function loadList(qydata) {
    qydata = JSON.parse(qydata);
    jq.ajax({
        url: "http://api.map.baidu.com/geocoder/v2/?address="+qydata.addr+"&output=json&ak=371WZUHBHUeqstdtnCHbkfYs1a7LMD7x",
        type: 'post',
        data: {
        },
        async: true,
        dataType: "json",
        success: function (data, textStatus) {
            $.hidePreloader();
            var person = data.result.location;
            var point = new BMap.Point(person.lng,person.lat);
            if(firstDrawMyLoc){
                mp.centerAndZoom(point, 15);
                firstDrawMyLoc = false;
            }
            ComplexCustomOverlay.prototype = new BMap.Overlay();
            ComplexCustomOverlay.prototype.initialize = function(map){
                this._map = map;
                var div = this._div = document.createElement("div");
                div.style.position = "absolute";
                div.style.zIndex = BMap.Overlay.getZIndex(this._point.lat);
                div.style.backgroundColor = "#EE5D5B";
                div.style.border = "1px solid #BC3B3A";
                div.style.color = "white";
                div.style.height = "18px";
                div.style.padding = "2px";
                div.style.lineHeight = "18px";
                div.style.whiteSpace = "nowrap";
                div.style.MozUserSelect = "none";
                div.style.fontSize = "12px"
                var span = this._span = document.createElement("span");
                div.appendChild(span);
                span.appendChild(document.createTextNode(this._text));
                var that = this;

                var arrow = this._arrow = document.createElement("div");
                arrow.style.background = "url(../../img/location.png) no-repeat";
                arrow.style.position = "absolute";
                arrow.style.width = "2rem";
                arrow.style.height = "2.5rem";
                arrow.style.top = "22px";
                arrow.style.left = "10px";
                arrow.style.overflow = "hidden";
                div.appendChild(arrow);

                div.onmouseover = function(){
                    this.style.backgroundColor = "#6BADCA";
                    this.style.borderColor = "#0000ff";
                    this.getElementsByTagName("span")[0].innerHTML = that._overText;
                    arrow.style.backgroundPosition = "0px -20px";
                }

                div.onmouseout = function(){
                    this.style.backgroundColor = "#EE5D5B";
                    this.style.borderColor = "#BC3B3A";
                    this.getElementsByTagName("span")[0].innerHTML = that._text;
                    arrow.style.backgroundPosition = "0px 0px";
                }

                mp.getPanes().labelPane.appendChild(div);

                return div;
            }
            ComplexCustomOverlay.prototype.draw = function(){
                var map = this._map;
                var pixel = map.pointToOverlayPixel(this._point);
                this._div.style.left = pixel.x - parseInt(this._arrow.style.left) + "px";
                this._div.style.top  = pixel.y - 30 + "px";
            }
            // var qyLon = parseFloat(person.lng);
            // var qyLat = parseFloat(person.lat);
            // var juli = parseInt(getFlatternDistance(qyLat,qyLon,selfLat,selfLon))/1000;
            var txt=qydata.entname;
            var myCompOverlay = new ComplexCustomOverlay(new BMap.Point(person.lng,person.lat), txt,txt);

            mp.addOverlay(myCompOverlay);

             // var qyLon = parseFloat(person.lng);
             // var qyLat = parseFloat(person.lat);
             // var juli = parseInt(getFlatternDistance(qyLat,qyLon,selfLat,selfLon))/1000;
            // jq('#person_ul').append("<li>"+qydata.entname+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+juli+"km<span class=\"distance\"></span></li>");
        },
        error: function (data, textStatus) {
            $.hidePreloader();
            $.alert("提示：服务链接异常。");
        }
    });
}

function callTel(number) {
    window.location.href = "tel:" + number;
}

// 复杂的自定义覆盖物
function ComplexCustomOverlay(point, text, mouseoverText){
    this._point = point;
    this._text = text;
    this._overText = mouseoverText;
}

function getFlatternDistance(lat1,lng1,lat2,lng2){
        var f = getRad((lat1 + lat2)/2);
        var g = getRad((lat1 - lat2)/2);
        var l = getRad((lng1 - lng2)/2);

        var sg = Math.sin(g);
        var sl = Math.sin(l);
        var sf = Math.sin(f);

        var s,c,w,r,d,h1,h2;
        var a = EARTH_RADIUS;
        var fl = 1/298.257;

        sg = sg*sg;
        sl = sl*sl;
        sf = sf*sf;

        s = sg*(1-sl) + (1-sf)*sl;
        c = (1-sg)*(1-sl) + sf*sl;

        w = Math.atan(Math.sqrt(s/c));
        r = Math.sqrt(s*c)/w;
        d = 2*w*a;
        h1 = (3*r -1)/2/c;
        h2 = (3*r +1)/2/s;

        return d*(1 + fl*(h1*sf*(1-sg) - h2*(1-sf)*sg));
}

 function getRad(d){
        return d*PI/180.0;
 }

/**
 *  加载列表数据
 */
function initData() {
    $.showPreloader("正在加载");
    var key = jq("#search").val();
    var taskTypeCode =  window.localStorage.getItem('taskTypeCode');
    var userName =  window.localStorage.getItem('username');
    var params = {
        key:key,
        recentdays:"0",
        page: 1,
        rows: '999999',
        taskTypeCode:taskTypeCode,
        userName:userName,
        queryType: window.localStorage.getItem('queryType'),
        url : "/appinterface/task/list.xhtml",
    }
    commonQuery(params,function (data) {
        try{
            if(data!=null){
                pageCount = data.data.pageCount;
                if(pageCount == 0 && pageNo ==1){
                    $.hidePreloader();
                    $.toast("未查询到相关数据。");
                    return;
                }
                for (var i = 0; i <data.data.resultList.length; i++) {
                    loadList(JSON.stringify(data.data.resultList[i]));
                }

            }else{
                $.toast("数据加载失败。");
            }
            $.hidePreloader();
        }catch (e){
        }finally {
            // dissmisLoad();
            loading = false;
        }


    });

    //
    // jq.ajax({
    //     url: ipconfig+"",
    //     type: 'post',
    //     data:,
    //     async: true,
    //     dataType: "json",
    //     success: function (data, textStatus) {
    //
    //     },
    //     error: function (data, textStatus) {
    //         $.hidePreloader();
    //         $.alert("服务链接异常。");
    //     }
    // });
}