define(["artTemplate", "echarts"], function (art, echarts) {
    return {
        params: null,
        setParams: function (data) {
            this.params = data;
        },
        getParams: function () {
            return this.params;
        },
        init: function () {
            var params = this.params;

            var lableSet = [];
            var ywcSet = [];
            var wwcSet = [];

            jq.each(params.data, function (code, obj) {
                if (code != "0000") {
                    lableSet.push(obj.FJNAME);
                    ywcSet.push(obj.YWC);
                    wwcSet.push(-obj.WWC);
                }
            });

            var myChart = echarts.init(jq('#chartmain')[0]);
            var option = {
                    tooltip : {
                        trigger: 'axis',
                        axisPointer : {            // 坐标轴指示器，坐标轴触发有效
                            type : 'shadow'        // 默认为直线，可选为：'line' | 'shadow'
                        }
                    },
                    legend: {
                        data:['已完成', '未完成'],
                        textStyle: {
                            color: 'white'
                        }
                    },
                    grid: {
                        left: '3%',
                        right: '10%',
                        bottom: '5%',
                        containLabel: true
                    },
                    xAxis : [
                        {
                            type : 'value',
                            axisLine:{
                                lineStyle:{
                                    color:'#fbae31'
                                }
                            }
                        }
                    ],
                    yAxis : [
                        {
                            type : 'category',
                            axisTick : {show: false},
                            data : lableSet,
                            axisLine:{
                                lineStyle:{
                                    color:'#fbae31'
                                }
                            }
                        }
                    ],
                    color : ['#fbae31','white'],
                    series : [
                        {
                            name:'已完成',
                            type:'bar',
                            stack: '总量',
                            label: {
                                normal: {
                                    show: false,
                                    position: 'right'
                                }
                            },
                            data:ywcSet
                        },
                        {
                            name:'未完成',
                            type:'bar',
                            stack: '总量',
                            label: {
                                normal: {
                                    show: false,
                                    position: 'left'
                                }
                            },
                            data:wwcSet
                        }
                    ]
                };
            myChart.setOption(option);
        }
    };
});