define(["artTemplate","text!tpls/info/info.html","info/echart","queryCommon"],function(art,infoTpl){
    return function(){
        jq(".module-container").html(infoTpl);

        var myDate = new Date();
        var currentDate= myDate.getFullYear()+"-"+((myDate.getMonth()+1) < 10 ? "0"+ (myDate.getMonth()+1): (myDate.getMonth()+1)); 
        jq("[name='startDate']").val(currentDate);
        jq("[name='endDate']").val(currentDate);

        jq(".reportClass").on("click", function () {
            //切换样式
            jq(".active").removeClass("active");
            jq(this).addClass("active");

            //重新加载数据
            loadReportInfo(art);
        });

        jq(".monthClass").on("change", function () {
            //重新加载数据
            loadReportInfo(art);
        });

        loadReportInfo(art);
    }
});

function loadReportInfo (art) {
    var type = jq(".active").attr("reportType");
    var startDate = jq("[name='startDate']").val();
    var endDate = jq("[name='endDate']").val();

    //第一天 
    var firstDateStr = "";
    if (null != startDate && undefined != startDate && "" != startDate) {
        var firstDate = startDate.split("-");
        var date = new Date(parseInt(firstDate[0],10), parseInt(firstDate[1],10)-1, 1);
        var dateStr = date.toLocaleDateString();
        dateStr=dateStr.replace("/","-");
        dateStr=dateStr.replace("/","-");
        var set = dateStr.split("-");
        firstDateStr = set[0]+"-"+(set[1].length > 1 ? set[1]: "0"+set[1])+"-"+(set[2].length > 1 ? set[2]: "0"+set[2])+" 00:00:01";
    }
    //最后一天
    var finalDateStr = "";
    if (null != endDate && undefined != endDate && "" != endDate) {
        var finalDate = endDate.split("-");
        var date = new Date(parseInt(finalDate[0],10), parseInt(finalDate[1],10), 0);
        var dateStr = date.toLocaleDateString();
        dateStr=dateStr.replace("/","-");
        dateStr=dateStr.replace("/","-");
        var set = dateStr.split("-");
        finalDateStr = set[0]+"-"+(set[1].length > 1 ? set[1]: "0"+set[1])+"-"+(set[2].length > 1 ? set[2]: "0"+set[2])+" 23:59:59";
    }

    var params = {
        "url": "appinterface/countAnalysis/toCalculate.xhtml",
        "typeCode": type,
        "startDate": firstDateStr,
        "endDate": finalDateStr
    };

    //调用查询方法
    var queryCommonJs = require("queryCommon");
    queryCommonJs.commonQuery(params, function (data) {
        jq("._reportTempTrClass").remove();
        //有缓存数据
        var reportItemListTpl = jq("#reportItemList").html();
        art.defaults.escape=false;
        var reportItemListHtml = art.render(reportItemListTpl, data);
        jq("#headTr").after(reportItemListHtml);

        //绘图
        var echartJs = require("info/echart");
        echartJs.setParams(data);
        echartJs.init();
    });
}