define(["artTemplate","text!tpls/inquire/annualReport.html","queryCommon","inquire/annualReportDetails"],function(art,annualReportTpl,queryCommonJs){
    return {
    	listCache: null,
    	putListCache: function (data) {
            this.listCache = data;
        },
        clearCache: function () {
            this.listCache = null;
        },
        loadData: function () {
        	var params = getFormData("dialog");

        	params['urlType'] = 'annualReport';
        	params['pageSize'] = 100;

        	//调用查询方法
        	queryCommonJs.query(params, function (data) {
        		//缓存数据 1
        		var annualReportJs = require("inquire/annualReport");
            	annualReportJs.putListCache(data);

            	//列表数据加载
        		var entItemListTpl = jq("#entItemList").html();
	            art.defaults.escape=false;
	            var entItemListHtml = art.render(entItemListTpl, data.data);
	            jq("#task-list").html(entItemListHtml);
	            //隐藏查询框
	            hideSearchDialog();
        	});
        },
    	init: function(){
	        jq(".module-container").html(annualReportTpl);
	        _annualreport_initQueryDialog();
	        //隐藏菜单
            hideFootbar(jq("#homeTipImg"));
	        // 返回上一个页面
            jq(".back").click(function(){
                var inquireJs = require("inquire/inquire");
                inquireJs();
            });

	        jq("#searchBtn").click(function () {
	        	showSearchDialog();
	        });

	        jq("#cancel").click(function() {
	        	hideSearchDialog();
	        });

	        jq("#queryBtn").click(function () {
	        	var annualReportJs = require("inquire/annualReport");
            	annualReportJs.loadData();
	        });

	        //加载列表
            if (null != this.listCache) {
                //有缓存数据
                var entItemListTpl = jq("#entItemList").html();
	            art.defaults.escape=false;
	            var entItemListHtml = art.render(entItemListTpl, this.listCache.data);
	            jq("#task-list").html(entItemListHtml);
            } else {
            	var annualReportJs = require("inquire/annualReport");
            	annualReportJs.loadData();
            }
	    }
    };
});

function _annualreport_initQueryDialog () {
	var fjEl = jq("#fj");

	//初始化分局
	var fjOptionHtml = "<option value=''>请选择</option>";
	jq.each(_FJ_LIST, function (code, lable) {
		var optionHtml = "<option value='"+code+"'>"+lable+"</option>";
		fjOptionHtml += optionHtml;
	});
	fjEl.html(fjOptionHtml);
}

function _annualreport_changeFj () {
	var ksEl = jq("#ks");
	var fj = jq("#fj").val();

	//初始化科所
	var ksOptionHtml = "<option value=''>请选择</option>";
	jq.each(_KS_LIST[fj], function (i, v) {
		var optionHtml = "<option value='"+v.ksCode+"'>"+v.ksName+"</option>";
		ksOptionHtml += optionHtml;
	});
	ksEl.html(ksOptionHtml);
}

function showAnnualReportDetails (entId,entType,parentUrl) {
    var annualReportDetailsJs = require("inquire/annualReportDetails");
    annualReportDetailsJs.setParams(entId,entType,parentUrl);
    annualReportDetailsJs.init();
}
