define(["artTemplate","text!tpls/inquire/integratedQuery.html","queryCommon","inquire/entDetails"],function(art,integratedQueryTpl,queryCommonJs){
    return {
    	listCache: null,
    	putListCache: function (data) {
            this.listCache = data;
        },
        clearCache: function () {
            this.listCache = null;
        },
        loadData: function () {
        	var entName = jq("[name='entName']").val();
        	var addr = jq("[name='addr']").val();
        	var industryphy = jq("#industryphy").val();
        	var fj = jq("#fj").val();
        	var ks = jq("#ks").val();
        	if (entName != null && "" != entName) {
        		entName = "01"+entName;
        	}

        	if (addr != null && "" != addr) {
        		addr = "01"+addr;
        	}

        	//整理参数 1
        	var params = {
        		'urlType':'marketEntity.integratedQuery',
        		'entName':entName,
        		'dom':addr,
        		'industryNo':industryphy,
        		'regorg':fj,
        		'adminbrancode':ks,
        		'pageSize': 100
        	};
        	//调用查询方法
        	queryCommonJs.query(params, function (data) {
        		//缓存数据
        		var quickSearchJs = require("inquire/integratedQuery");
            	quickSearchJs.putListCache(data);

            	//列表数据加载
        		var entItemListTpl = jq("#entItemList").html();
	            art.defaults.escape=false;
	            var entItemListHtml = art.render(entItemListTpl, data.data);
	            jq("#task-list").html(entItemListHtml);
	            //隐藏查询框
	            hideSearchDialog();
        	});
        },
    	init: function(){
	        jq(".module-container").html(integratedQueryTpl);
	        _integrated_initQueryDialog();
	        //隐藏菜单
            hideFootbar(jq("#homeTipImg"));
	        // 返回上一个页面
            jq(".back").click(function(){
                var inquireJs = require("inquire/inquire");
                inquireJs();
            });

	        jq("#searchBtn").click(function () {
	        	showSearchDialog();
	        });

	        jq("#cancel").click(function() {
	        	hideSearchDialog();
	        });

	        jq("#queryBtn").click(function () {
	        	var quickSearchJs = require("inquire/integratedQuery");
            	quickSearchJs.loadData();
	        });

	        //加载列表
            if (null != this.listCache) {
                //有缓存数据
                var entItemListTpl = jq("#entItemList").html();
	            art.defaults.escape=false;
	            var entItemListHtml = art.render(entItemListTpl, this.listCache.data);
	            jq("#task-list").html(entItemListHtml);
            } else {
            	var quickSearchJs = require("inquire/integratedQuery");
            	quickSearchJs.loadData();
            }
	    }
    };
});

function _integrated_initQueryDialog () {
	var industryphyEl = jq("#industryphy");
	var fjEl = jq("#fj");

	//初始化industryphy
	var industryphyOptionHtml = "<option value=''>请选择</option>";
	jq.each(_industryphy, function (i, v) {
		var optionHtml = "<option value='"+v.value+"'>"+v.lable+"</option>";
		industryphyOptionHtml += optionHtml;
	});
	industryphyEl.html(industryphyOptionHtml);

	//初始化分局
	var fjOptionHtml = "<option value=''>请选择</option>";
	jq.each(_FJ_LIST, function (code, lable) {
		var optionHtml = "<option value='"+code+"'>"+lable+"</option>";
		fjOptionHtml += optionHtml;
	});
	fjEl.html(fjOptionHtml);
}

function _integrated_changeFj () {
	var ksEl = jq("#ks");
	var fj = jq("#fj").val();

	//初始化科所
	var ksOptionHtml = "<option value=''>请选择</option>";
	jq.each(_KS_LIST[fj], function (i, v) {
		var optionHtml = "<option value='"+v.ksCode+"'>"+v.ksName+"</option>";
		ksOptionHtml += optionHtml;
	});
	ksEl.html(ksOptionHtml);
}
