define(["artTemplate", "text!tpls/report/checkRemark.html","report/placereport","report/taskedit","queryCommon"], function (art, checkRemarkTpl) {
    return {
        params : null,
        setParams: function (taskId,entId,entName,queryType) {
            this.params = {
                'taskId':taskId,
                'entId':entId,
                'entName':entName,
                'queryType':queryType
            };
        },
        getParams: function () {
            return this.params;
        },
        init: function () {
            var params = this.params;
            jq(".module-container").html(checkRemarkTpl);

            jq("#entName").text(params.entName);

            // 返回上一个页面
            jq(".back").click(function(){
                var taskedit = require("report/taskedit");
                taskedit.setParams(params.taskId,params.entId,params.entName,params.queryType);
                taskedit.initTask();
            });

            // 下一个页面
            jq("#next").click(function(){
                nextPlaceReport(params);
            });

            loadCheckRemarkData(art, params);
        }
    };
});

/*
 * 加载任务检查情况数据
 */
function loadCheckRemarkData(art, params) {
    var urlconfig = window.localStorage.getItem("urlconfig");
    var url=urlconfig+"appinterface/task/querySite.xhtml";

    params['url']="appinterface/task/querySite.xhtml";
    var queryCommonJs = require("queryCommon");
    queryCommonJs.commonQuery(params, function (data) {
        if (data.success == true) {
            var checkItemList = $("#checkItemList").html();
            art.defaults.escape=false;
            var checkItemListHtml = art.render(checkItemList, data.data);
            jq("#checkItemsId").html(checkItemListHtml);

            //展示评级
            var quanlevel = data.data.quanlevel;
            if (undefined != quanlevel && "" != quanlevel) {
                jq(".checkResult").show();
                jq("#levelSpanId").text(quanlevel);
                jq("#levelRemarkId").text("关键项目不符合（"+data.data.zdCount+"）项、一般项目不符合（"+data.data.ybCount+"）项");
            }

            var myDate = new Date();
            var currentDate= myDate.getFullYear(); 
            currentDate += "-"+((myDate.getMonth()+1) < 10 ? "0"+ (myDate.getMonth()+1): (myDate.getMonth()+1));
            currentDate += "-"+(myDate.getDate() < 10 ? "0"+ myDate.getDate(): myDate.getDate());

            var dataSet = jq(".Wdate");
            jq.each(dataSet, function (i, el) {
                var val = jq(el).val();
                if (null == val || "" == val) {
                    jq(el).val(currentDate);
                }
            });

            //修改日期控件为html5日期控件
            jq(".Wdate").attr("type", "date");
            jq(".Wdate").attr("readonly", false);
            jq(".Wdate").css("width", "200px");
        } else {
            $.alert(data.message);
        }
    });

}

/**
 * 保存检查反馈数据
 * @return {[type]} [description]
 */
function nextPlaceReport (params) {
    if ("yb" == params.queryType) {
        //下一步 展示地图，选择图片
        var placereportJs = require("report/placereport");
        placereportJs.setParams(params.taskId, params.entId, params.entName, params.queryType);
        placereportJs.init();
    } else {
        // 保存内容，进行下一步
        var datas = getFormData("checkItemsId");
        //携带参数
        $.extend(datas, params);

        datas['url']="appinterface/task/saveSite.xhtml";
        var queryCommonJs = require("queryCommon");
        queryCommonJs.commonQuery(datas, function (data) {
            if (data.success == true) {
                //下一步 展示地图，选择图片
                var placereportJs = require("report/placereport");
                placereportJs.setParams(params.taskId, params.entId, params.entName);
                placereportJs.init();
            } else {
                $.alert(data.message);
            }
        });
    }
}

function WdatePicker() {
}