define(["artTemplate", "text!tpls/report/imgupload.html","report/placereport"], function (art, imguploadTpl) {
    return {
        params : null,
        setParams: function (taskId,entId,entName,queryType) {
            this.params = {
                'taskId':taskId,
                'entId':entId,
                'entName':entName,
                'queryType':queryType
            };
        },
        getParams: function () {
            return this.params;
        },
        loadImg: function () {
            var params = this.params;
            var queryType = params.queryType;
            var $list = jq("#filePicker");
            //调用接口删除附件
            var urlconfig = window.localStorage.getItem("urlconfig");
            var token = window.sessionStorage.getItem("token");
            var url = "appinterface/upload/queryPicturesList.xhtml";

            var queryCommonJs = require("queryCommon");
            queryCommonJs.commonQuery({'taskId':params.taskId,'url':url}, function (data) {
                $.each(data.data, function (i, obj) {
                    var url = urlconfig+"/appinterface/upload/showPictures.xhtml?token="+token+"&id="+obj.VCHR_ID;

                    //获取当前所有图片数量
                    var size = jq(".deleteImg").length;
                    //计算删除按钮偏移量
                    var top = (0.24+0.1)+(2.7+0.24*2)*parseInt(size/3); // 单位rem
                    var left = (2.7+0.24*2-0.7/2-0.2)+(2.7+0.24*2)*(size%3);//单位rem

                    var file = {'id': obj.VCHR_ID};
                    var $li,$img;
                    if ("yb" == queryType) {
                        $li = jq(
                        '<div id="' + file.id + '" class="file-item thumbnail">' +
                            '<img>' +
                        '</div>'
                        );
                    } else {
                        $li = jq(
                        '<div id="' + file.id + '" class="file-item thumbnail">' +
                            '<a href="javascript:void(0);" onclick="removeFile(\''+file.id+'\')" '+
                            '   class="deleteImg" style="top:'+top+'rem;left:'+left+'rem;"></a>' +
                            '<img>' +
                        '</div>'
                        );
                    }
                    $img = $li.find('img');
                    
                    // $list为容器jQuery实例
                    $img.attr("src",url);
                    $list.before( $li );
                });
            });
        },
        init: function () {
            var ImgJs = this;
            var params = ImgJs.params;
            jq(".module-container").html(imguploadTpl);

            if ("yb" == params.queryType) {
                jq("#filePicker").hide();
                jq("#nextPage").text("退回");
            }

            ImgJs.loadImg();

            // 返回上一个页面
            jq(".back").click(function(){
                var placereportJs = require("report/placereport");
                placereportJs.setParams(params.taskId, params.entId, params.entName, params.queryType);
                placereportJs.init();
            });

            jq("#filePicker").click(function () {
                ImgJs.showAddPic();
            });
            jq("#addPicDiv").click(function () {
                ImgJs.hideAddPic();
            });
            //打开相册
            jq("#photoDiv").click(function () {
                ImgJs.openPhoto();
            });
            //打开相机
            jq("#cameraDiv").click(function () {
                ImgJs.openCamera();
            });
        },
        showAddPic: function () {
            jq("#addPicDiv").show();    
            jq("#addPicDialog").show();
        },
        hideAddPic: function () {
            jq("#addPicDiv").hide();    
            jq("#addPicDialog").hide();
        },
        openCamera: function () {
            var ImgJs = this;
            navigator.camera.getPicture(ImgJs.onSuccess, ImgJs.onFail, {
                quality: 50,
                destinationType: navigator.camera.DestinationType.FILE_URI,
                sourceType: navigator.camera.PictureSourceType.CAMERA
                // mediaType: navigator.camera.MediaType.VIDEO //这一行可以从图库选视频，不设置，默认是图片
            });
        },
        openPhoto: function () {
            var ImgJs = this;
            window.imagePicker.getPictures(
                function(results) {
                    for (var i = 0; i < results.length; i++) {
                        ImgJs.onSuccess(results[i]);
                    }
                }, ImgJs.onFail,{
                    maximumImagesCount:50
                });
        },
        addPic: function (id, imageURI) {
            var $list = jq("#filePicker");
            //获取当前所有图片数量
            var size = jq(".deleteImg").length;
            //计算删除按钮偏移量
            var top = (0.24+0.1)+(2.7+0.24*2)*parseInt(size/3); // 单位rem
            var left = (2.7+0.24*2-0.7/2-0.2)+(2.7+0.24*2)*(size%3);//单位rem

            var $li = jq(
                    '<div id="' + id + '" class="file-item thumbnail">' +
                        '<a href="javascript:void(0);" onclick="removeFile(\''+id+'\')" '+
                        '   class="deleteImg" style="top:'+top+'rem;left:'+left+'rem;"></a>' +
                        '<img>' +
                    '</div>'
                    ),
                $img = $li.find('img');
            $img.attr('src', imageURI);
            // $list为容器jQuery实例
            $list.before($li);
        },
        downloadFile: function(uri, fileURL, callBack) {
            var fileTransfer = new FileTransfer();
            fileTransfer.download(
                uri, fileURL,
                function (entry) {
                    callBack();
                },

                function (error) {
                    console.log("download error code" + error.code);
                },

                false, {
                    headers: {
                        "Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
                    }
                }
            );
        },
        readFileCallBack: function (data) {
            var ImgJs = require("report/imgupload");
            var fileName = data.fileName;
            if ("success" == data.result) {
                //上传
                var params = ImgJs.getParams();
                // 保存内容，进行下一步
                var datas = {
                    'taskId': params.taskId,
                    'fileName': fileName,
                    'userName': window.localStorage.getItem("username"),
                    'fileContent': data.data
                };

                datas['url']="appinterface/upload/savePictures.xhtml";
                var queryCommonJs = require("queryCommon");
                queryCommonJs.commonQuery(datas, function (data) {
                    if (data.success == true) {
                        var fileURL = cordova.file.externalRootDirectory + '/hangyjx/photo/' + fileName;
                        ImgJs.addPic(data.data.id, fileURL);
                    } else {
                        $.alert(data.message);
                    }
                });
            }
        },
        saveImg: function (fileName) {
            var ImgJs = require("report/imgupload");
            cordova.exec(ImgJs.readFileCallBack,null,'ReadFilePlugin','readAsBinaryString',[fileName]);
        },
        onSuccess: function (imageURI) {
            var ImgJs = require("report/imgupload");
            var fileName = (new Date()).valueOf() + "";
            var fileURL = cordova.file.externalRootDirectory + '/hangyjx/photo/' + fileName + '.jpg';
            ImgJs.hideAddPic();
            ImgJs.downloadFile(imageURI, fileURL, function () {
                ImgJs.saveImg(fileName+".jpg");
            });
        },
        onFail: function () {

        }
    };
});

/**
 * 提交
 * @return 
 */
function submitData () {
    //获取参数
    var imguploadJs = require("report/imgupload");
    var params = imguploadJs.getParams();
    
    if ("yb" == params.queryType) {
        var taskListJs = require("report/taskList");
        taskListJs.initTaskList();
    } else {
        $.confirm('提交之后内容不可修改，确定提交吗？', function () {
            params['userName'] = window.localStorage.getItem("username");
            params['url'] = "appinterface/task/changeStatus.xhtml";
            var queryCommonJs = require("queryCommon");
            queryCommonJs.commonQuery(params, function (data) {
                if (data.success == true) {
                    //返回任务列表
                    cordova.exec(null,null,'WidgetPlugin','toast',['提交成功']);
                    var taskListJs = require("report/taskList");
                    taskListJs.clearCacheInit();
                } else {
                    $.alert(data.message);
                }
            });
        }, function () {
            //取消
        });
    }
}

function removeFile (fileId) {
    //调用接口删除附件
    var params = {
        'id': fileId,
        'url': "appinterface/upload/deletePictures.xhtml"
    };

    var queryCommonJs = require("queryCommon");
    queryCommonJs.commonQuery(params, function (data) {
        removeEl(fileId);
    });
}
function removeEl (fileId) {
    jq("#"+fileId).remove();

    var aMark = jq(".deleteImg");
    jq.each(aMark, function (i, v) {
        //计算删除按钮偏移量
        var top = (0.24+0.1)+(2.7+0.24*2)*parseInt(i/3); // 单位rem
        var left = (2.7+0.24*2-0.7/2-0.2)+(2.7+0.24*2)*(i%3);//单位rem
        jq(v).css('top', top+"rem");
        jq(v).css('left', left+"rem");
    });
}
