define(["artTemplate", "text!tpls/report/placereport.html","report/checkRemark","report/imgupload"], function (art, placereportTpl) {
    return {
        params : null,
        interval: null,
        setParams: function (taskId,entId,entName,queryType) {
            this.params = {
                'taskId':taskId,
                'entId':entId,
                'entName':entName,
                'queryType':queryType
            };
        },
        getParams: function () {
            return this.params;
        },
        initMapPoint: function () {
            // 保存内容，进行下一步
            var params = {
                'entId': this.entId
            };

            //携带参数
            params['url'] = "appinterface/task/queryEntSite.xhtml";
            var queryCommonJs = require("queryCommon");
            queryCommonJs.commonQuery(params, function (data) {
                this.interval = self.setInterval(function () {
                    document.getElementById("baiduMapIframe").contentWindow.postMessage({'lat':data.data.wd,'lng':data.data.jd,'type':'baiduMap'},"*");
                },100);
            });
        },
        init: function () {
            var params = this.params;
            jq(".module-container").html(placereportTpl);

            this.initMapPoint();

            //接收 子页面的通信信息  
            window.addEventListener('message',function(e){
                var loc = e.data;
                if (loc && loc.type == 'baiduMap') {
                    jq("#placeInfo").val(loc.addr);
                    jq("#lat").val(loc.point.lat);
                    jq("#lng").val(loc.point.lng);
                } else if (loc && loc.type == 'closeBaiduMap') {
                    jq("#mapDiv").hide();
                } else if (loc && loc.type == 'setBaiDuMapParams') {
                    window.clearInterval(this.interval);
                } 
            },false);  

            jq("#mapshow").on('click', function () {
                jq("#mapDiv").show();
            });

            // 返回上一个页面
            jq(".back").click(function(){
                var checkRemarkJs = require("report/checkRemark");
                checkRemarkJs.setParams(params.taskId, params.entId, params.entName, params.queryType);
                checkRemarkJs.init();
            });
        }
    };
});

/**
 * 下一步
 * @return 
 */
function nextImgUpload () {
    //获取参数
    var placereport = require("report/placereport");
    var params = placereport.getParams();

    if ("yb" == params.queryType) {
        var imguploadJs = require("report/imgupload");
        imguploadJs.setParams(params.taskId, params.entId, params.entName, params.queryType);
        imguploadJs.init();
    } else {
        // 保存内容，进行下一步
        var datas = {
            'longitude':jq("#lng").val(),
            'latitude': jq("#lat").val()
        };

        //携带参数
        $.extend(datas, params);
        datas['url'] = "appinterface/task/saveEntSite.xhtml";
        var queryCommonJs = require("queryCommon");
        queryCommonJs.commonQuery(datas, function (data) {
            if (data.success == true) {
                var imguploadJs = require("report/imgupload");
                imguploadJs.setParams(params.taskId, params.entId, params.entName);
                imguploadJs.init();
            } else {
                $.alert(data.message);
            }
        });
    }
}