define(["artTemplate","text!tpls/report/tasklist.html","report/taskedit","queryCommon"],function(art,tasklistTpl,taskeditJs){
    return {
        params : null,
        listCache: {},
        setParams: function (recentdays, taskTypeCode, otherParams, queryType) {
            this.params = {
                'recentdays':recentdays,
                'taskTypeCode':taskTypeCode,
                'otherParams':otherParams,
                'queryType': queryType
            };
        },
        getParams: function () {
            return this.params;
        },
        putListCache: function (data) {
            //页面数据缓存
            var tempList = this.listCache[this.params.taskTypeCode+"_"+this.params.queryType];
            var list = null;
            if (undefined != tempList && undefined != tempList.data && undefined != tempList.data.resultList) {
                list = tempList.data.resultList;

                $.each(data.data.resultList, function (i,v) {
                    list.push(v);
                });
            } else {
                list = data.data.resultList;
            }

            this.listCache[this.params.taskTypeCode+"_"+this.params.queryType] = {
                'data': {
                    'nextPageNo': data.data.nextPageNo,
                    'lastPageNo': data.data.lastPageNo,
                    'resultList': list
                }
            };
        },
        clearCache: function () {
            this.listCache[this.params.taskTypeCode+"_"+this.params.queryType] = null;
        },
        refreshFun: function () {
            var params = this.params;
            var tasklistModelTpl = $("#taskList").html();
            jq("#task-list").html("");
            jq("[name='nextPageNo']").val("1");
            this.clearCache();
            loadTaskListData(art, tasklistModelTpl, params, 'refresh');
        },
        clearCacheInit: function () {
            this.clearCache();
            this.initTaskList();
        },
        initTaskList: function() {
            var taskListThis = this;
            var params = this.params;
            jq(".module-container").html(tasklistTpl);
            var tasklistModelTpl = $("#taskList").html();

            if ("yb" == params.queryType) {
                jq("#taskListSpan").text("已办任务列表");
                tasklistModelTpl = $("#taskListShow").html();
            }
            //隐藏菜单
            hideFootbar(jq("#homeTipImg"));

            // 自动加载
            jq(".list").scroll(function(){  
                // 卷曲高度
                var scrollTop=jq(".list").scrollTop();
                // 总的高度
                var htmlHeight=jq(".list")[0].scrollHeight;
                // 可视高度
                var clientHeight=jq(".list").height();

                if(scrollTop+clientHeight >= (htmlHeight-2)){ 
                    loadTaskListData(art, tasklistModelTpl, params, '');
               }
            });

            // 返回上一个页面
            jq(".back").click(function(){
                jq('.home').trigger('click');
            });

            //刷新列表
            jq("#refreshTaskId").click(function () {
                taskListThis.refreshFun();
            });

            //加载列表
            if (null != this.listCache[params.taskTypeCode+"_"+params.queryType]) {
                //有缓存数据
                jq("[name='nextPageNo']").val(this.listCache[params.taskTypeCode+"_"+params.queryType].data.nextPageNo);
                jq("[name='lastPageNo']").val(this.listCache[params.taskTypeCode+"_"+params.queryType].data.lastPageNo);

                var taskListHtml=art.render(tasklistModelTpl,this.listCache[params.taskTypeCode+"_"+params.queryType].data);
                jq("#task-list").append(taskListHtml);
            } else {
                loadTaskListData(art, tasklistModelTpl, params, '');
            }
        }
    };
});

/**
 * 进入明细
 */
function taskDetail (taskId,entId,entName) {
    var taskListJs = require("report/taskList");
    var params = taskListJs.getParams();

    var taskedit = require("report/taskedit");
    taskedit.setParams(taskId, entId, entName, params.queryType);
    taskedit.initTask();
}

function putCache(data) {
    var taskListJs = require("report/taskList");
    taskListJs.putListCache(data);
}

function clearCache() {
    var taskListJs = require("report/taskList");
    taskListJs.clearCache();
}

/*
 * 加载任务列表数据
 */
function loadTaskListData(art, tasklistModelTpl, params, refresh) {
    var nextPageNo = jq("[name='nextPageNo']").val();
    var lastPageNo = jq("[name='lastPageNo']").val();

    if (undefined != refresh && 'refresh' == refresh) {
        params['page'] = 1;
    } else {
        if (undefined != nextPageNo && null != nextPageNo && "" != nextPageNo && undefined != lastPageNo && null != lastPageNo && "" != lastPageNo) {
            if (nextPageNo == lastPageNo) {
                cordova.exec(null,null,'WidgetPlugin','toast',['没有更多数据']);
                return;
            } else {
                params['page'] = nextPageNo;
            }
        }
    }

    params['url'] = "appinterface/task/list.xhtml";

    var queryCommonJs = require("queryCommon");
    queryCommonJs.commonQuery(params, function (data) {
        if (data.success == true) {
            putCache(data);

            jq("[name='nextPageNo']").val(data.data.nextPageNo);
            jq("[name='lastPageNo']").val(data.data.lastPageNo);

            var taskListHtml=art.render(tasklistModelTpl,data.data);
            jq("#task-list").append(taskListHtml);
        } else {
            $.alert(data.message);
        }
    });
}

/**
 * 任务关注
 */
 function toTaskCare(taskId,type){
    var params = {
        'userName':window.localStorage.getItem('username'),
        'url':'appinterface/task/taskCare.xhtml',
        'type':type,
        'taskId':taskId
    };
    
    var queryCommonJs = require("queryCommon");
    queryCommonJs.commonQuery(params, function (data) {
        if (data.success == true) {
            cordova.exec(null,null,'WidgetPlugin','toast',[data.message]);
            //返回任务列表
            var taskListJs = require("report/taskList");
            taskListJs.refreshFun();
        } else {
            $.alert(data.message);
        }
    });
 }