(function () {
    document.addEventListener("pause", onPause, false);
}());

/**
 * 程序切换到后台自动保存草稿
 */
function onPause() {
    console.log("onPause");
    draftSave("auto");
}

/**
 * 弹框确认框是否保存草稿
 * @param type task 检查结果保存草稿
 */
function confirmSaveDraft(type) {
    $.modal({
        title: '是否要存草稿?',
        buttons: [
            {
                text: '否',
                onClick: function () {
                    if (type && type == 'task') {
                        clearTaskDraft();
                    } else  {
                        clearDraft();
                    }
                    onBack();
                }
            },
            {
                text: '存草稿',
                onClick: function () {
                    // 保存草稿并返回上级页面
                    draft("back");
                }
            },
        ]
    });
}

function draft(type) {
    draftSave();

    if (type == "back") {
        history.back(-1);
    } else {
        closeAndBack();
    }
}

/**
 * 保存检查结果草稿， 根据餐企ID和TaskId保存草稿
 *
 * @param entId
 * @param taskTypeCode
 * @param taskId
 */
function taskDraftKeySave(entId, taskTypeCode, taskId) {
    var uipath = window.localStorage.getItem("uipath");
    var taskDraftKeys = {entId: entId, taskTypeCode: taskTypeCode, taskId: taskId, uipath: uipath}
    console.log("taskDraftKeys " + entId + "--->" + JSON.stringify(taskDraftKeys))
    window.localStorage.setItem("taskDraftKeys" + entId, JSON.stringify(taskDraftKeys));
}

/**
 * 根据餐企id获取保存的草稿记录
 *
 * @param entId
 * @returns {any}
 */
function loadTaskDraftKey(entId) {
    var taskDraftKeys = window.localStorage.getItem("taskDraftKeys" + entId);
    return JSON.parse(taskDraftKeys);
}

/**
 * 清除检查结果草稿
 */
function clearTaskDraft() {
    var queryType = window.localStorage.getItem("queryType");
    if (queryType == "add_Case") {
        window.localStorage.setItem(queryType, "");
    } else {
        var qydata = JSON.parse(window.localStorage.getItem("dataList"));
        var draftKeys = loadTaskDraftKey(qydata.entId);
        if (draftKeys) {
            window.localStorage.removeItem(draftKeys.taskId);
        }
        window.localStorage.removeItem("taskDraftKeys" + qydata.entId);
    }
}

function loadDraft(draftKey) {
    var queryType = window.localStorage.getItem("queryType");
    var draftData = "";
    console.log("loadDraft -->" + queryType + draftKey)
    if (queryType == "add_Case") {
        draftData = window.localStorage.getItem(queryType);
    } else {
        window.localStorage.setItem("draftKey", draftKey);
        draftData = window.localStorage.getItem(draftKey);
    }

    if (draftData != '' && draftData != undefined) {
        console.log("loadDraft --> " + draftData);
        echoForm(JSON.parse(draftData));
    } else {
        console.log(draftKey + " 没有草稿数据");
    }
}

function showChoice(id, name, add) {
    jq("input[type='checkbox'][value='" + id + "']").attr('checked', true);
    jq("#" + name).val(name);
    jq("#" + id).val(id);
    name && $(add).html(name);
}

function draftSave(type) {
    var queryType = window.localStorage.getItem("queryType");
    var key = "";
    if (queryType == "add_Case") {
        key = queryType;
    } else {
        key = window.localStorage.getItem("draftKey");
    }

    var draftData = null;
    if (typeof getDraftDataCallback != "undefined") {
        draftData = getDraftDataCallback();
    } else {
        draftData = JSON.stringify(jq("#form1").serializeObject());
    }
    console.log("draftSave --> " + draftData);
    window.localStorage.setItem(key, draftData);
    if (type !== "auto") {
        $.toast('草稿保存成功。');
    }
}

function clearDraft() {
    deleteAllPictures();
    var queryType = window.localStorage.getItem("queryType");
    if (queryType == "add_Case") {
        window.localStorage.removeItem(queryType);
    } else {
        var draftKey = window.localStorage.getItem("draftKey")
        if (null != draftKey) {
            window.localStorage.removeItem(draftKey);
        }
    }
}