/******
 *  审计信息界面
 *
 * */
var jq = jQuery.noConflict();
var taskId;
var baseid;
(function () {
    document.addEventListener("deviceready", onDeviceReady, false);
})();

function onDeviceReady() {
    var qydata  = JSON.parse(window.localStorage.getItem("dataList"));
    taskId =qydata.taskid;
    initData(taskId);
    initEvent();
}


function initEvent() {
    //公示信息审查结果选择不相符时。审计不符合项列表要显示出来、添加审计不符合项按钮也要显示出来
    
}


/**
 *  加载列表数据
 */
function initData(taskId) {
    $.showPreloader("正在加载");
    var params = {
        taskId:taskId,
        url: "/appinterface/ssg/querySJInfo.xhtml"
    };

    commonQuery(params, function(data) {
        try{
            if(data.success){
                window.localStorage.setItem("sjxx",JSON.stringify(data.data));
                initSjInfo(data.data);

            }else{
                $.toast("数据加载失败。");
            }
            $.hidePreloader();
        }catch (e){

        }
    });
}

function initSjInfo(data) {
    var sjinfo = data.info;
    baseid = sjinfo.baseid;
    //0 待审计   1：待审批  2：已审计
    $("input[name='xcjcqk'][value='"+sjinfo.situation+"']").attr("checked",true);
    $("input[name='gsxxscjg'][value='"+sjinfo.nb_result+"']").attr("checked",true);
    $("#cclxr").val(sjinfo.contact);
    $("#cclxdh").val(sjinfo.con_tel);
    $("#remark").val(sjinfo.remark);
    /*公示信息审查结果为不符合项时。添加审计不符合项和不符合项列表隐藏*/
    if(sjinfo.nb_result == "0"){
        $("#addsjbfhx").show();
        $("#bfhxList").show();
    }

    /*审计信息不符合项*/
    if(data.itemList && data.itemList.length>0){
        var html = '';
        for (var i = 0; i < data.itemList.length; i++) {
            console.log("scxm_value="+scxm_value+",sxlb_value="+sxlb_value+",sxmc_value="+sxmc_value);
            var lis = '<li class="business-list_item">' +
                '<span class="business-litem_label">审查项目</span>' +
                '<span class="business-litem_value">'+data.itemList[i].infotype+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">事项类别</span>' +
                '<span class="business-litem_value">'+data.itemList[i].items+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">事项名称</span>' +
                '<span class="business-litem_value">'+data.itemList[i].content+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">公示信息</span>' +
                '<span class="business-litem_value">'+data.itemList[i].publics+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">实际情况</span>' +
                '<span class="business-litem_value">'+data.itemList[i].reality+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">差异</span>' +
                '<span class="business-litem_value">'+data.itemList[i].different+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">录入人名称</span>' +
                '<span class="business-litem_value">'+data.itemList[i].entry_name+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">备注</span>' +
                '<span class="business-litem_value">'+data.itemList[i].remark+'</span>' +
                '</li>' +
                '<li class="business-list_item">' +
                '<span class="business-litem_label">操作</span>' +
                '<span class="business-litem_value">'+data.itemList[i].remark+'</span>' +
                '</li>'
            html+='<h1 class="business-title">基础信息</h1>' +
                '<ul class="business-list">' +
                 lis+
                '</ul>'
        }
        $("#bfhxList").append(html);
    }

    if(sjinfo.STATE == "2"){
        jq("input[type='radio']").attr("disabled", "disabled");
        jq("input[type='checkbox']").attr("disabled", "disabled");
        jq("input[type='text']").attr("disabled", "disabled");
        jq("#remark").attr("readonly", true);
    }else if(sjinfo.state == "1"){

    }else if(sjinfo.state == "0") {

    }
}

function sjComfirm() {
    var xcjcqk = $("input[name=xcjcqk]:checked").val();
    if(xcjcqk==undefined || xcjcqk== ""){
        $.toast("请选择录入现场检查情况");
        return;
    }
    var cclxr = $("input[name=cclxr]").val();
    if(cclxr==undefined || cclxr== ""){
        $.toast("请录入抽查联系人信息");
        return;
    }
    var cclxdh = $("input[name=cclxdh]").val();
    if(cclxdh==undefined || cclxdh== ""){
        $.toast("请录入抽查联系人电话");
        return;
    }

    var gsxxscjg = $("input[name=gsxxscjg]:checked").val();
    if(gsxxscjg==undefined || gsxxscjg== ""){
        $.toast("请选择公示信息审查结果");
        return;
    }

    var confirmMsg = "是否确认提交审计信息，提交后不支持修改";
    $.modal({
        text: confirmMsg,
        buttons: [
            {
                text: '取消',
                onClick: function () {
                    $.closeModal();
                }
            },
            {
                text: "确认提交",
                onClick: function () {
                    submit();
                }
            }
        ]
    })
}

function submit() {
    var xcjcqk = $("input[name=xcjcqk]:checked").val();
    var gsxxscjg = $("input[name=gsxxscjg]:checked").val();
    var cclxr = $("input[name=cclxr]").val();
    var cclxdh = $("input[name=cclxdh]").val();
    var remark = $("#remark").val();
    $.showPreloader("正在加载");
    var params = {
        situation:xcjcqk,
        nb_result:gsxxscjg,
        contact:cclxr,
        con_tel:cclxdh,
        remark:remark,
        baseid:baseid,
        url: "/appinterface/ssg/updateSJBASEById.xhtml"
    };

    commonQuery(params, function(data) {
        try{
            if(data.success){
                $.toast(data.message);
            }else{
                $.toast("数据加载失败。");
            }
            $.hidePreloader();
        }catch (e){

        }
    });
}



function initEvent() {

}

/****
 * 添加审计不符合项
 * */
function addSjbfhx(){
    window.location.href = 'ssj_sjxxbfhx.html';
}


/*******
 * sjlx
 * sjsxdx
 * sjsxxx
 *
 * */
function findCodeTable(codeTable,parentCode,targetCode) {
    $.showPreloader("正在加载");
    var params = {
        codeTable:codeTable,
        parentCode:parentCode,
        url: "/appinterface/codetable/findCodeTable.xhtml"
    };
    commonQuery(params, function(data) {
        try{
            if(data.success){
                var items = data.data;
            }else{
                $.toast("数据加载失败。");
            }
            $.hidePreloader();
        }catch (e){

        }
    });
}

