var uniqueCode;
var type;
var name;
var selStartTime;
var selEndTime;
var statisticsData;
(function () {
    document.addEventListener("deviceready",onDeviceReady,false);
    uniqueCode = queryUrlParam('uniqueCode');
    type = queryUrlParam('type');
    name = queryUrlParam('name');
    selStartTime = queryUrlParam('startTime');
    selEndTime = queryUrlParam('endTime');
    $('.title').text(name);
    registerEvent();
    onDeviceReady();
})();

function onDeviceReady() {
    refreshView();
}
//注册事件
function registerEvent() {
    $("#startDatePicker").calendar({
        onOpen: function () {
            $('#area-wrapper').hide()
        },
        // onClose:function () {
        //     refreshView();
        // }
    })
    $("#endDatePicker").calendar({
        onOpen: function () {
            $('#area-wrapper').hide()
        },
        // onClose:function () {
        //     refreshView();
        // }
    })
    $("#startDatePicker").val(selStartTime);
    $("#endDatePicker").val(selEndTime);
    $(document).on("click",'.address-item-button',function(){
        refreshView();
    });
}

function addTaskEvent() {
    var percentParent = $('.wrap-content').eq(0).find('ul');
    percentParent.on("click","li",function () {
        var data = statisticsData[$(this).index()];
        if(data.name === '其他')return;
        //0-市局；1-分局；2-监管所；3-网格
        if(data.type === '0' || data.type === '1'){//
            window.location.href = 'statisticsDepartment.html?uniqueCode='+
                data.uniqueCode+'&type='+data.type+'&name='+data.name+'&startTime='+selStartTime+'&endTime='+selEndTime;
        }else if(data.type === '2'){
            window.location.href = 'statisticsDetail.html?uniqueCode='+
                data.uniqueCode+'&type='+data.type+'&name='+data.name+'&startTime='+selStartTime+'&endTime='+selEndTime;
        }
    });
}

//刷新页面
function refreshView() {
    var startTime = $('.address-time-container').find('input').eq(0).val();
    var endTime = $('.address-time-container').find('input').eq(1).val();
    if(!uniqueCode || !type || !name || !startTime || !endTime)return;
    requestData(startTime,endTime,uniqueCode,type);
}

//请求统计数据
function requestData(startTime,endTime,uniqueCode,type) {

    var params = {
        uniqueCode : uniqueCode,
        startTime:startTime,
        endTime:endTime,
        type:type,
        url:"/appinterface/statistics/task.xhtml"
    };

    commonQuery(params,function (data) {
        if (data.success === true){
            statisticsData = data.data;
            StatisticsView();
        }
    });
}

/**
 * @return {string}
 */
function ChangeDateFormat(date) {
    var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
    var currentDate = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();
    return date.getFullYear() + "-" + month + "-" + currentDate;
}

//填充页面数据
function StatisticsView() {
    var percentParent = $('.wrap-content').eq(0).find('ul');
    percentParent.empty();
    var percentStr = '';
    var detailParent = $('.flex-list');
    detailParent.empty();
    //0-市局；1-分局；2-监管所；3-网格
    var detailStr =
        '<li><p>监管所</p>' +
        '<p>总数</p>' +
        '<p>已完成</p>'+
        '<p>未完成</p>'+
        '<p>完成率</p></li>';
    var per;
    for(var index in statisticsData)
    {
        // per = statisticsData[index].completionRate;
        // percentStr += '<li class="progress">'+
        //     '<span  class="f-name">'+statisticsData[index].name+'</span>'+
        //     '<div class="f-progress">'+
        //     '<div style="width: '+(per?per:0)+';" class="f-bar"></div>'+
        //     '</div>'+
        //     '<span class="f-percent">'+(per?per:0)+'</span>'+
        //     (statisticsData[index].name === '其他' ?
        //             '':
        //             ('<img class="f-icon" src="../../images/common/icon_small_arrow.png" alt=""/>')
        //     ) +
        //     '</li>';
        var proportionRate = statisticsData[index].proportionRate;
        var completionRate = statisticsData[index].completionRate;
        percentStr += '<li class="progress">' +
            '<span class="f-name">' + statisticsData[index].name + '</span>' +
            '<div class="f-progress">' +
            '<div style="width: ' + (proportionRate ? proportionRate : '0%') + ';" class="f-bar"></div>' +
            '</div>' +
            '<span class="f-percent">' + (proportionRate ? proportionRate : '0%') + '</span>' +
            ((statisticsData[index].name === '其他') ?
                    '&nbsp;&nbsp;' :
                    ('<img class="f-icon" src="../../images/common/icon_small_arrow.png" alt=""/>')
            ) +
            '</li>';
        detailStr  +=
            '<li><p>'+statisticsData[index].name+'</p>'+
            '<p>'+statisticsData[index].total+'</p>'+
            '<p>'+statisticsData[index].completedQty+'</p>'+
            '<p>'+statisticsData[index].uncompletedQty+'</p>'+
            '<p>'+(completionRate? completionRate:0)+'</p></li>';
    }
    percentParent.append(percentStr);
    detailParent.append(detailStr);
    addTaskEvent();
}