'use strict';

Array.prototype.indexOf = function (val) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] === val) return i;
    }
    return -1;
};

Array.prototype.remove = function (val) {
    var index = this.indexOf(val);
    if (index > -1) {
        this.splice(index, 1);
    }
};

(function () {
    document.addEventListener("deviceready", onDeviceReady, false);
})();

function onDeviceReady() {};
var app = new Vue({
    el: '#app',
    data: {
        isEditStates: false,
        states: '编辑',
        selectList: [],
        earlyWarningList: [],
        initEarlyWarningList:[],
        sortable:'',
        list:[],
    },
    components: {},
    methods: {
        editOrCompleteClick: function editOrCompleteClick() {
            this.isEditStates = !this.isEditStates;
            this.states = this.isEditStates ? '完成' : '编辑';
            setUserLocalStorage('selectList',JSON.stringify(this.selectList))
            // 接口
            // 如果不是编辑状态，禁用拖拽
            this.sortable.option("disabled", !this.isEditStates)
            if(!this.isEditStates) {
                var params = {
                    userId: window.localStorage.getItem('username'),
                    url: "appinterface/workbench/saveWorkbench.xhtml",
                    dataMap:JSON.stringify(this.selectList)
                };
                commonQuery(params, function (data) {
                    if (data.success == true) {
                    }
                });
            }
        },
        cancelClick: function cancelClick() {
            this.isEditStates = false;
            this.states = '编辑';
            // 如果不是编辑状态，禁用拖拽
            this.sortable.option("disabled", true);
            if(getUserLocalStorage('selectList')){
                this.selectList = JSON.parse(getUserLocalStorage('selectList'));
            } else {
                this.selectList = [];
            }
            this.initData();
        },
        deleteClick: function deleteClick(item) {
            var _this = this;
            this.selectList.forEach(function (value) {
                if (item.benchCode === value.benchCode) {
                    _this.selectList.remove(value);
                }
            });
            this.earlyWarningList.forEach(function (value) {
                value.items.forEach(function (value1) {
                    if (value1.benchCode === item.benchCode) {
                        value1.show = true;
                    }
                });
            });
        },
        addOrDeleteClick: function addOrDeleteClick(item) {
            if (item.show) {
                if (this.selectList.length === 8) {
                    $.toast("工作台最多可添加8个预警类型");
                } else {
                    this.selectList.push(item);
                    this.earlyWarningList.forEach(function (value) {
                        value.items.forEach(function (value1) {
                            if (value1.benchCode === item.benchCode) {
                                value1.show = false;
                            }
                        });
                    });
                }
            } else {
                this.deleteClick(item);
            }
        },
        itemClick: function itemClick(item) {
            if (!this.isEditStates) {
                var equipmentIndex;
                if(item.benchCode === '101') equipmentIndex = '1';
                if(item.benchCode === '102') equipmentIndex = '2';
                if(item.benchCode === '103') equipmentIndex = '3';
                if(item.benchCode === '104') equipmentIndex = '4';
                window.localStorage.setItem('equipmentIndex', equipmentIndex);
                if(item.benchCode === '203') {
                    toHealthCertificateWarning();
                } else if(item.benchCode === '204') {
                    toSafetyCerWarning();
                } else if(item.benchCode === '201'|| item.benchCode === '301'||item.benchCode === '301') {
                    toDetectionWarning();
                } else {
                    window.location.href = '../' + item.url;
                }

            }
        },
        initData: function initData() {
            var _this2 = this;
            this.earlyWarningList = JSON.parse(window.localStorage.getItem('earlyWarningList'));
            this.earlyWarningList.forEach(function (value) {
                value.items.forEach(function (value1) {
                    value1.show = true;
                    _this2.selectList.forEach(function (value2) {
                        if (value2.benchCode === value1.benchCode) {
                            value1.show = false;
                        }
                    });
                });
            });
        }
    },
    watch: {},
    mounted: function mounted() {
        if(getUserLocalStorage('selectList')){
            this.selectList = JSON.parse(getUserLocalStorage('selectList'));
        }
        this.initData();

        <!-- 初始化拖拽功能 -->
        var el = document.getElementById('sortableItems');
        this.sortable = Sortable.create(el, {disabled: true,
            onEnd:function(evt){
                app.selectList.splice(evt.newIndex, 0, app.selectList.splice(evt.oldIndex, 1)[0]);
                var newArray = app.selectList.slice(0);
                app.selectList = [];
                app.$nextTick(function () {
                    app.selectList = newArray;
                });
            }});
    }
});