var jq = jQuery.noConflict();

require.config({
    baseUrl: "../js/ydjg/",
    paths: {
        "text": "lib/text",
        "jquery": "../jquery-1.9.1",
        "zepto": "../zepto.min",
        "artTemplate": "lib/template-web",
        "echarts": "lib/echarts.min",
        "tpls":"../../ydjg_html/tpl",
        "queryCommon": "queryCommon"
    }
});

var temp = 0;
//返回按键触发事件
function onBackKeyDown() {
    if (temp == 0) { //temp为0代表尚未弹出confirm
        temp = 1;//temp为1代表已弹出confirm对话框，从而不再触发返回事件
        $.confirm('确定退出应用？', function () {
            navigator.app.exitApp();  //用户点击确定，退出app
        }, function () {
            temp = 0;  //如果用户点击取消，使temp恢复为0
        });
    } else if (temp == 1) {
        //temp为1时不执行任何操作
    }
}

function toEntListPage(businessType,type) {
    var entListJs = require("report/entList");
    entListJs.setParams('',businessType,{},type);
    entListJs.initTaskList();
}

function toTaskListPage(type) {
    var taskListJs = require("report/taskList");
    taskListJs.setParams('',type,{},'db');
    taskListJs.initTaskList();
}

function toCareTaskPage() {
    var taskListJs = require("report/taskList");
    taskListJs.setParams('','',{},'gz');
    taskListJs.clearCacheInit();
}

function toexpiredTaskList() {
    Initialize();
    jq('.report').children("div").css("background-image","url('../img/yiban02.png')");
    jq('.report').css("color","#9abdde");
    var taskListJs = require("report/taskList");
    taskListJs.setParams('7','',{});
    taskListJs.initTaskList();
}

function toallTodoTaskList() {
    Initialize();
    jq('.report').children("div").css("background-image","url('../img/yiban02.png')");
    jq('.report').css("color","#9abdde");
    var taskListJs = require("report/taskList");
    taskListJs.setParams('0','',{});
    taskListJs.initTaskList();
}

// 导航图标重置
function Initialize(){
    jq(".home").children("div").css("background-image","url('../img/home01.png')");
    jq(".report").children("div").css("background-image","url('../img/yiban01.png')");
    jq(".search").children("div").css("background-image","url('../img/search01.png')");
    jq(".info").children("div").css("background-image","url('../img/tongji01.png')");
    jq(".quzheng").children("div").css("background-image","url('../img/info01.png')");
    jq(".home").css("color","#7f7f7f");
    jq(".report").css("color","#7f7f7f");
    jq(".search").css("color","#7f7f7f");
    jq(".info").css("color","#7f7f7f");
    jq(".quzheng").css("color","#7f7f7f");
}

function showFootbar (el) {
    jq(el).attr("src", "../img/down_03.png");
    jq(el).removeClass("hidefoot").addClass("showfoot");
    jq("#_content").removeClass("hidefootbar").addClass("showfootbar");
    jq("#_footbar").show();
    jq(".homeTip").css("bottom","15%");
}

function hideFootbar (el) {
    jq(el).attr("src", "../img/up_03.png");
    jq(el).removeClass("showfoot").addClass("hidefoot");
    jq("#_content").removeClass("showfootbar").addClass("hidefootbar");
    jq("#_footbar").hide();
    jq(".homeTip").css("bottom","4%");
    jq(".homebox").css("height","78%");
}

function showHideFootbar() {
    var el = jq("#homeTipImg");
    var classVal = jq(el).attr("class");
    if ("showfoot" == classVal) {
        hideFootbar(el);
    } else if ("hidefoot" == classVal) {
        showFootbar(el);
    }
}

/*
 * 加载首页数据
 */
function loadHomeData(art, homeTpl) {
    var params = {
        'url': "appinterface/workware/taskCount.xhtml"
    };
    var queryCommonJs = require("queryCommon");
    queryCommonJs.commonQuery(params, function (data) {
        if (data.success == true) {
            var $homeTpl=jq(art.render(homeTpl,data.data));
            jq(".module-container").html($homeTpl);
        } else {
            $.alert(data.message);
        }
    });
    
}

function showAlert(content){
    // window.localStorage.setItem('username',content.username);
    window.localStorage.setItem('username',"huangzp");

    require(["artTemplate","report/report","inquire/inquire","info/info","text!tpls/home.html","report/taskList","info/quzheng","report/entList"], function (art,reportJS,inquireJS,infoJS,homeTpl,taskListJs,quzhengJs,entListJs) {
        // 导航栏点击事件

        // 首页点击事件
        jq('.home').on("click", function () {
            Initialize();
            jq(this).children("div").css("background-image","url('../img/home02.png')");
            jq(this).css("color","#9abdde");
            var dataJsonTemp = {
                'userName': window.localStorage.getItem('username'),
                'expiredTaskCount': '0',
                'allTodoTaskCount': '0',
                'qiguan': {
                    'entCount': '0',
                    'addCount': '0',
                    'unclaimedCount': '0'
                },
                'canyin': {
                    'entCount': '0',
                    'addCount': '0',
                    'unclaimedCount': '0'
                },
                'liutong': {
                    'entCount': '0',
                    'addCount': '0',
                    'unclaimedCount': '0'
                },
                'shengchan': {
                    'entCount': '0',
                    'addCount': '0',
                    'unclaimedCount': '0'
                }
            };
            var $homeTpl=jq(art.render(homeTpl,dataJsonTemp));
            jq(".module-container").html($homeTpl);
            showFootbar(jq("#homeTipImg"));
            loadHomeData(art, homeTpl);
        });

        // 已办点击事件
        jq('.report').on("click", function () {
            Initialize();
            jq(this).children("div").css("background-image","url('../img/yiban02.png')");
            jq(this).css("color","#9abdde");

            var taskListJs = require("report/taskList");
            taskListJs.setParams('','',{},'yb');
            taskListJs.initTaskList();
        });
        // 查询点击事件
        jq('.search').on("click", function () {
            Initialize();
            jq(this).children("div").css("background-image","url('../img/search02.png')");
            jq(this).css("color","#9abdde");
            inquireJS();

        });
        // 统计点击事件
        jq('.info').on("click", function () {
            Initialize();
            jq(this).children("div").css("background-image","url('../img/tongji02.png')");
            jq(this).css("color","#9abdde");
            infoJS();
        });

        // 取证点击事件
        jq('.quzheng').on("click", function () {
            Initialize();
            jq(this).children("div").css("background-image","url('../img/info02.png')");
            jq(this).css("color","#9abdde");
            quzhengJs();
        });

        document.addEventListener("backbutton", onBackKeyDown, true);
        jq('.home').trigger('click');
    });
}